import pandas as pd
import numpy as np
import scipy.stats as ss
from drawmap import *

#
#       Excelファイルの読み込み
#
flnm = input('Data File Name (*.xlsx) = ')
xlsx = pd.ExcelFile(flnm)       
data = pd.read_excel(xlsx)  

X = data.values
var_names = data.columns.values
print(var_names)
n = len(X[0]) - 1
JM = len(X)
print('n = ', n)
print('JM = ', JM)

case_labels = X[:,0]
print('case_labels = ', case_labels)

xi = np.empty((JM, n))                  #   入力データ
for i in range(JM):
    for j in range(n):
        xi[i][j] = X[i][j + 1]
print('xi =\n', xi)

g_size = 10
m = np.empty((g_size, g_size, n))       #   参照ベクトル
for i in range(g_size):
    for j in range(g_size):
        for k in range(n):
            m[i][j][k] = ss.uniform.rvs()

t_max = 100
diffs = np.empty((g_size, g_size))
a_0 = 0.5
sgm_t = g_size / 2
for t in range(t_max):
    print('t = ', t)
    a_t = a_0 * (t_max - t) / t_max
    for IN in range(JM):
        for i in range(g_size):
            for j in range(g_size):
                diffs[i][j] = ((m[i][j] - xi[IN]) ** 2).sum()
        tc = np.argmin(diffs)       #   勝者ベクトル
        tc_i = tc // g_size         #   勝者ベクトルの行位置
        tc_j = tc % g_size          #   勝者ベクトルの列位置
        #
        #       参照ベクトルの更新
        #
        for i in range(g_size):
            for j in range(g_size):
                h_cr_IN = a_t * np.exp(-((i - tc_i)**2 + (j - tc_j)**2) /
                                       (2 * (sgm_t**2)))
                m[i][j] = m[i][j] + h_cr_IN * (xi[IN] - m[i][j])

    sgm_t = 1 + (sgm_t - 1) * (t_max - t) / t_max
        
#
#       マップの描画
#
draw_som(case_labels, xi, m)

