import pandas as pd
import numpy as np
import scipy.stats as ss
from map2clusters import *

#
#       Excelファイルの読み込み
#
flnm = input('Data File Name (*.xlsx) = ')
xlsx = pd.ExcelFile(flnm)               
data = pd.read_excel(xlsx)          

X = data.values
var_names = data.columns.values
print(var_names)
n = len(X[0]) - 1
JM = len(X)
print('n = ', n)
print('JM = ', JM)

case_labels = X[:,0]
print('case_labels = ', case_labels)

xi = np.empty((JM, n))          #   入力データ
for i in range(JM):
    for j in range(n):
        xi[i][j] = X[i][j + 1]
print('xi =\n', xi)

g_size = 2
m = np.empty((g_size, n))       #   参照ベクトル
for i in range(g_size):
    for k in range(n):
            m[i][k] = ss.uniform.rvs()
#print('m[0] = n', m[0])

t_max = 100
diffs = np.empty(g_size)
a_0 = 0.5
sgm_t = g_size / 2
for t in range(t_max):
    print('t = ', t)
    a_t = a_0 * (t_max - t) / t_max
    for IN in range(JM):
        for i in range(g_size):
            diffs[i] = ((m[i] - xi[IN]) ** 2).sum()
        tc = np.argmin(diffs)
        for i in range(g_size):
            h_cr_IN = a_t * np.exp(-((i - tc)**2) /
                                       (2 * (sgm_t**2)))
            m[i] = m[i] + h_cr_IN * (xi[IN] - m[i])

    sgm_t = 1 + (sgm_t - 1) * (t_max - t) / t_max
        
        
draw_som_2clusters(case_labels, xi, m)

