import matplotlib.pyplot as plt
import numpy as np

def draw_som_2clusters(case_labels, xi, m):
    JM = len(xi)
    n = len(xi[0])
    g_size = len(m)

    diffs0 = []
    diffs1 = []
    for i in range(JM):
        v = ((m[0] - xi[i]) ** 2).sum()
        diffs0.append(v)
        v = ((m[1] - xi[i]) ** 2).sum()
        diffs1.append(v)
    

    plt.plot(diffs0, diffs1, 'bo')
    for j in range(JM):
        plt.text(diffs0[j], diffs1[j], case_labels[j])
    plt.xlabel('$Dist.^2$ from Unit-0', fontsize = 12)
    plt.ylabel('$Dist.^2$ from Unit-1', fontsize = 12)
    plt.show()

